;            
;===============================================
;-----------------------------------------------
;
;    	Win32definitions                                          
;
;	Author:	metheus@gmx.net
;
;-----------------------------------------------
;
;	-Includefile
;	-nasm syntax
;-----------------------------------------------
;
;	08.08.98
;	-17.02.99 converted to nasm syntax
;-----------------------------------------------
;===============================================
;	 	
;
;=======================================================================================
;
;	TYPE DEFINITIONS
;
;=======================================================================================
;
%define	ACHAR 		BYTE		;ansi character
%define ATOM 		DWORD		;string atom
%define BOOL 		DWORD		;boolean variable
%define	COLORREF	DWORD		;rgb color
%define	DWORDLONG 	QWORD		;long double word
%define	GLOBALHANDLE 	DWORD		;global handle
%define HACCEL	 	DWORD		;accelerator handle
%define HANDLE	 	DWORD		;unspecified handle
%define	HBITMAP	 	DWORD		;bitmap handle
%define	HBRUSH	 	DWORD		;brush handle
%define	HCOLORSPACE 	DWORD		;color space handle
%define	HCURSOR	 	DWORD		;cursor handle
%define	HCD 		DWORD		;device context handle
%define	HDWP 		DWORD		;defer win pos handle
%define	HENHMETAFILE 	DWORD		;enh. metafile handle
%define	HFILE 		DWORD		;file handle
%define	HFONT		DWORD		;font handle
%define	HGLOBAL	 	DWORD		;global handle
%define	HHOOK 		DWORD		;hook handle
%define	HICON 		DWORD		;icon handle
%define	HINSTANCE	DWORD		;instance handle
%define	HINTERNET 	DWORD		;internet handle
%define	HLOCAL 		DWORD		;local handle
%define	HMENU 		DWORD		;menu handle
%define	HMETAFILE 	DWORD		;metafile handle
%define	HPALETTE 	DWORD		;palette handle
%define	HPEN 		DWORD		;pen handle
%define	HRGN 		DWORD		;region handle
%define	HRSRC	 	DWORD		;resource handle
%define	HSTR 		DWORD		;string handle
%define	HTASK	 	DWORD		;task handle
%define	HTREEITEM 	DWORD		;tree view item handle
%define	HWND 		DWORD		;window handle
%define	INTEGER	 	DWORD		;standard integer
%define	LOCALHANDLE 	DWORD		;local handle
%define	LONG 		DWORD		;long integer
%define	LONGINT	 	DWORD		;long integer
%define	LPARAM		DWORD		;long parameter
%define LPBOOL	 	DWORD		;long ptr to boolean
%define LPBYTE	 	DWORD		;long ptr to byte
%define LPCSTR	 	DWORD		;long ptr to string
%define LPCTSTR	 	DWORD		;long ptr to string
%define	LPCVOID 	DWORD		;long ptr to buffer
%define	LPDWORD	 	DWORD		;long ptr to dword
%define LPFN	 	DWORD		;long ptr to function
%define LPINT	 	DWORD		;long ptr to integer
%define LPLONG	 	DWORD		;long ptr to long int
%define LPSTR 		DWORD		;long ptr to string
%define LPTSTR 		DWORD		;long ptr to string
%define	LPVOID 		DWORD		;long ptr to buffer
%define	LPWORD	 	DWORD		;long ptr to word
%define LRESULT 	DWORD		;long result
%define POINTER	 	DWORD		;pointer to anything
%define PVOID 		DWORD		;pointer to buffer
%define	SHORTINT 	WORD		;short integer
%define	UINT 		DWORD		;unsigned integer
%define	WCHAR 		WORD		;unicode character
%define	WNDPROC 	DWORD		;window procedure
%define	WPARAM 		DWORD		;word parameter
 ;
;=======================================================================================
;
;	CONSTANTS	
;
;=======================================================================================
;


;-----------------------------------------------
;	File access
;-----------------------------------------------
;

MAX_PATH		EQU	260
;
;DesiredAccess (CreateFile)
GENERIC_READ		EQU	080000000h
GENERIC_WRITE		EQU	040000000h
GENERIC_EXECUTE		EQU	020000000h
GENERIC_ALL		EQU	010000000h

;ShareMode	
FILE_SHARE_READ         EQU     00000001h
FILE_SHARE_WRITE        EQU     00000002h

;CreationDistribution
CREATE_NEW		EQU	01h
CREATE_ALWAYS		EQU	02h
OPEN_EXISTING		EQU	03h
OPEN_ALWAYS		EQU	04h
TRUNCATE_EXISTING	EQU	05h

;flProtect (CreateFileMapping)
PAGE_READONLY           EQU     00000002h
PAGE_READWRITE          EQU     00000004h
PAGE_WRITECOPY          EQU     00000008h
SEC_IMAGE               EQU     01000000h
SEC_RESERVE             EQU     04000000h
SEC_COMMIT              EQU     08000000h
SEC_NOCACHE             EQU     10000000h

;DesiredAccess (MapViewOfFile)
FILE_MAP_COPY           EQU     00000001h
FILE_MAP_WRITE          EQU     00000002h
FILE_MAP_READ           EQU     00000004h
 
;Standard File Handles
STD_INPUT_HANDLE	EQU	-10
STD_OUTPUT_HANDLE	EQU	-11
STD_ERROR_HANDLE	EQU	-12

;File Attributes
FILE_ATTRIBUTE_READONLY         EQU     00000001h
FILE_ATTRIBUTE_HIresdEN         EQU     00000002h
FILE_ATTRIBUTE_SYSTEM           EQU     00000004h
FILE_ATTRIBUTE_DIRECTORY        EQU     00000010h
FILE_ATTRIBUTE_ARCHIVE          EQU     00000020h
FILE_ATTRIBUTE_NORMAL           EQU     00000080h
FILE_ATTRIBUTE_TEMPORARY        EQU     00000100h
FILE_ATTRIBUTE_ATOMIC_WRITE     EQU     00000200h
FILE_ATTRIBUTE_XACTION_WRITE    EQU     00000400h
FILE_ATTRIBUTE_COMPRESSED       EQU     00000800h
FILE_ATTRIBUTE_HAS_EMBEresdING  EQU     00001000h


;
;-----------------------------------------------
;	MessageBox
;-----------------------------------------------
;
;  MessageBox type flags
MB_OK                   EQU 	0000H
MB_OKCANCEL             EQU 	0001H
MB_ABORTRETRYIGNORE     EQU 	0002H
MB_YESNOCANCEL          EQU 	0003H
MB_YESNO                EQU 	0004H
MB_RETRYCANCEL          EQU 	0005H

MB_ICONHAND             	EQU 	0010H
MB_ICONQUESTION         	EQU 	0020H
MB_ICONEXCLAMATION      	EQU 	0030H
MB_ICONASTERISK         	EQU 	0040H

MB_DEFBUTTON1           	EQU 	0000H
MB_DEFBUTTON2           	EQU 	0100H
MB_DEFBUTTON3           	EQU 	0200H

MB_APPLMODAL            	EQU 	0000H
MB_SYSTEMMODAL          	EQU 	1000H
MB_TASKMODAL            	EQU 	2000H

MB_NOFOCUS              	EQU 	8000H

;	OS ID
;
VER_PLATFORM_WIN32s		EQU	0
VER_PLATFORM_WIN32_WINDOWS	EQU	1
VER_PLATFORM_WIN32_NT		EQU	2
;
;=======================================================================================
;
;	STRUCTURES	
;
;=======================================================================================
;			

;
;-----------------------------------------------
;	File Access
;-----------------------------------------------
;
STRUC	FILETIME  
        FT_reswLowDateTime      	resd 1
	FT_reswHighDateTime		resd 1
ENDSTRUC	

STRUC   WIN32_FIND_DATA
        WFD_reswFileAttributes  	resd 	1
        WFD_ftCreationTime      	resb 	FILETIME_size
        WFD_ftLastAccessTime:   	resb 	FILETIME_size
        WFD_ftLastWriteTime:    	resb 	FILETIME_size
        WFD_nFileSizeHigh       	resd 	1
        WFD_nFileSizeLow  		resd 	1
        WFD_reswReserved0       	resd 	1
        WFD_reswReserved1       	resd 	1
        WFD_cFileName           	resb 	MAX_PATH 
        WFD_cAlternateFileName  	resb 	13+3 
ENDSTRUC

STRUC 	BY_HANDLE_FILE_INFORMATION   
    	HFI_dwFileAttributes		resd 	1
    	HFI_ftCreationTime		resb	FILETIME_size
    	HFI_ftLastAccessTime		resb	FILETIME_size
    	HFI_ftLastWriteTime		resb	FILETIME_size
    	HFI_dwVolumeSerialNumber	resd	1
        HFI_nFileSizeHigh		resd	1
        HFI_nFileSizeLow		resd	1
        HFI_nNumberOfLinks 		resd	1
        HFI_nFileIndexHigh 		resd	1
        HFI_nFileIndexLow 		resd	1
ENDSTRUC

STRUC 	PROCESS_INFORMATION	
	PI_hProcess			resd 	1
	PI_hThread			resd 	1
	PI_reswProcessId		resd 	1
	PI_reswThreadId			resd 	1
ENDSTRUC

STRUC	OS_VERSION_INFO
    	OVI_dwOSVersionInfoSize 	resd 	1	
    	OVI_dwMajorVersion		resd	1
    	OVI_dwMinorVersion 		resd	1
    	OVI_dwBuildNumber 		resd	1
    	OVI_dwPlatformId 		resd	1
    	OVI_szCSDVersion	 	resb	080h
ENDSTRUC

;
;-----------------------------------------------
;	Structured Exception Handling
;-----------------------------------------------
;
STRUC	ERR_STRUCTURE
	ERR_lpNextERRStructure		resd	1
	ERR_lpExceptionHandler		resd	1
	ERR_EIP				resd	1
	ERR_Information			resd	1
	ERR_Flags			resd	1
	ERR_EBP				resd	1
	ERR_Data			resd	1
ENDSTRUC


	
;
;-----------------------------------------------
;	Time
;-----------------------------------------------
;
STRUC 	SYSTEM_TIME
	ST_Year		resw	1
	ST_Month	resw	1
	ST_DayOfWeek	resw	1
	ST_Day		resw	1
	ST_Hour		resw	1
	ST_Minute	resw	1
	ST_Seconds	resw	1
	ST_Milliseconds	resw	1
ENDSTRUC

;
;=======================================================================================
;
;	MACROS	
;
;=======================================================================================
;
%MACRO  jmp_invalid_handle  1
	inc	eax
	jz	%1
	dec	eax
%ENDMACRO 

%MACRO	push_edi_esi 0
	push	edi
	push	esi
%ENDMACRO

%MACRO	pop_esi_edi 0
	pop	esi
	pop	edi
%ENDMACRO

%MACRO	push_edi_esi_ebp 0
	push	edi
	push	esi
	push	ebp
%ENDMACRO

%MACRO	pop_ebp_esi_edi 0
	pop	ebp
	pop	esi
	pop	edi
%ENDMACRO